/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.DisponibilidadDAO;
import com.rjconsultores.ventaboletos.entidad.Corrida;
import com.rjconsultores.ventaboletos.entidad.Disponibilidad;
import com.rjconsultores.ventaboletos.service.DisponibilidadService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

/**
 *
 * @author wallace
 */
@Service("disponibilidadService")
public class DisponibilidadServiceImpl implements DisponibilidadService {

    @Autowired
    private DisponibilidadDAO disponibilidadDAO;

    public List<Disponibilidad> obtenerTodos() {
        return disponibilidadDAO.obtenerTodos();
    }

    public Disponibilidad obtenerID(Integer id) {
        return disponibilidadDAO.obtenerID(id);
    }

    @Transactional
    public Disponibilidad suscribir(Disponibilidad entidad) {
    	Integer usuarioId = 1;
    	if (UsuarioLogado.getUsuarioLogado() != null){
    		usuarioId = UsuarioLogado.getUsuarioLogado().getUsuarioId();
    	}
        entidad.setUsuarioId(usuarioId);
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return disponibilidadDAO.suscribir(entidad);
    }

    @Transactional
    public Disponibilidad actualizacion(Disponibilidad entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return disponibilidadDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(Disponibilidad entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        disponibilidadDAO.actualizacion(entidad);
    }

	@Override
	public void borrarByCorrida(Corrida corrida) {
		disponibilidadDAO.borrarByCorrida(corrida);
		
	}
}
